package com.lindosoft.android.guide.controller;

import android.app.Activity;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;
import com.lindosoft.android.guide.model.MainModel;
import com.lindosoft.android.guide.model.Point;
import com.lindosoft.android.guide.model.SightModel;

/** Record single point. */
public abstract class AbstractRecordActivity extends Activity {
  protected MediaRecorder recorder = null;

  /** Handle stop button. */
  public void stop(View view) {
    finish();
  }


  /** Specify the point name. */
  protected abstract String getName();

  /** Specify the point output file. */
  protected abstract String getOutputFile();

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.record);
  }

  @Override
  protected void onPause() {
    try {
      recorder.stop();
      recorder.release();
    } catch (Exception ex) {
    }
    recorder = null;
    super.onPause();
  }

  @Override
  protected void onResume() {
    super.onResume();
    TextView pointName = (TextView) findViewById(R.id.text_point_name);
    pointName.setText(getName());
    recordPoint();
  }


  /** Record point audio. */
  private void recordPoint() {
    try {
      recorder = new MediaRecorder();
      recorder.setAudioSource(MainModel.audioSource);
      recorder.setOutputFormat(MainModel.audioFormat);
      recorder.setOutputFile(getOutputFile());
      recorder.setAudioEncoder(MainModel.audioEncoder);
      recorder.setAudioSamplingRate(MediaRecorder.AudioEncoder.AMR_NB >= MainModel.audioEncoder ? 8000 : 48000);
      recorder.prepare();
      recorder.start();
    } catch (Exception ex) {
      Toast.makeText(this, "recordPoint(): " + ex, Toast.LENGTH_LONG).show();
      finish();
    }
  }
}