package com.lindosoft.android.guide.controller;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.View;
import com.lindosoft.android.guide.model.MainModel;

/** Show main menu. */
public class MainActivity extends Activity {
  /** Help clicked. */
  public void onHelp(View view) {
    String help = "http://android.lindosoft.com/?page_id=13";
    Uri uri = Uri.parse(help);
    Intent intent = new Intent(Intent.ACTION_VIEW, uri);
    startActivity(intent);
  }

  /** Settings clicked. */
  public void onSettings(View view) {
    Intent intent = new Intent(this, SettingsActivity.class);
    startActivity(intent);
  }

  /** Sights clicked. */
  public void onSights(View view) {
    Intent intent = new Intent(this, SightsActivity.class);
    startActivity(intent);
  }

  /** Tours clicked. */
  public void onTours(View view) {
    Intent intent = new Intent(this, ToursActivity.class);
    startActivity(intent);
  }


  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.main);
  }

  @Override
  protected void onResume() {
    super.onResume();
    MainModel.readSettings(PreferenceManager.getDefaultSharedPreferences(this));
  }
}