package com.lindosoft.android.guide.controller;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Toast;
import com.lindosoft.android.guide.model.MainModel;
import com.lindosoft.android.guide.model.TourModel;

/** Create new tourpoint. */
public class TourpointNewActivity extends AbstractLocationListActivity {
  protected boolean locked = false;

  @Override
  public void onBackPressed() {
    if (locked) {
      return;
    }
    stopLocation();
    super.onBackPressed();
  }

  /** Direction button clicked. */
  public void onDirection(View view) {
    if (locked || null == location) {
      return;
    }
    switch(view.getId()) {
      case R.id.direction1:
        createTourpoint("b1");
        break;
      case R.id.direction2:
        createTourpoint("b2");
        break;
      case R.id.direction3:
        createTourpoint("b3");
        break;
      case R.id.direction4:
        createTourpoint("b4");
        break;
      case R.id.direction5:
        createTourpoint("b5");
        break;
      case R.id.direction6:
        createTourpoint("b6");
        break;
      case R.id.direction7:
        createTourpoint("b7");
        break;
      case R.id.direction8:
        createTourpoint("b8");
        break;
      case R.id.direction9:
        createTourpoint("b9");
        break;
      case R.id.direction10:
        createTourpoint("b10");
        break;
      case R.id.direction11:
        createTourpoint("b11");
        break;
      case R.id.direction12:
        createTourpoint("b12");
        break;
    }
  }

  /** Toggle active/locked. */
  public void onLock(View view) {
    locked = !locked;
  }

  /** Record button clicked. */
  public void onRecord(View view) {
    if (locked || null == location) {
      return;
    }
    createTourpoint(null);
    Intent intent = new Intent(this, TourpointRecordActivity.class);
    startActivity(intent);
  }


  @Override
  protected void handleLocation() {
  }

  @Override
  protected void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.tourpoint_new);
    startLocation();
  }

  @Override
  protected void onDestroy() {
    stopLocation();
    super.onDestroy();
  }


  /** Create tourpoint. */
  private void createTourpoint(String name) {
    try {
      if (null == name) {
        name = getResources().getString(R.string.default_tourpoint_name) + MainModel.audioExtension;
        TourModel.createTourpoint(location, name);
      } else {
        TourModel.createTourpoint(location, name);
        Toast.makeText(this, "Tourpoint " + name + " created", Toast.LENGTH_SHORT).show();
        playNotification();
      }
    } catch (Exception ex) {
      Toast.makeText(this, "createTourpoint(" + name + "): " + ex, Toast.LENGTH_LONG).show();
    }
  }
}