package com.lindosoft.android.guide.model;

import android.content.SharedPreferences;
import android.os.Environment;
import java.io.File;

/** Main shared data. */
public class MainModel {
  public static final String HOME = "lindoguide";
  public static final String RESOURCES = "resources";
  public static int audioEncoder = 0;
  public static String audioExtension = ".mp3";
  public static int audioFormat = 0;
  public static int audioSource = 0;
  public static long intervalPlay = 0L;
  public static long intervalRecord = 0L;
  public static float radiusPlay = 0.0F;
  public static float radiusRecord = 0.0F;

  /** Read settings from shared preferences. */
  public static void readSettings(SharedPreferences preferences) {
    String settingAudio = preferences.getString("setting_audio", "1/1");
    String[] tokens = settingAudio.split("/");
    audioEncoder = Integer.parseInt(tokens[0]);
    audioFormat = Integer.parseInt(tokens[1]);
    audioSource = Integer.parseInt(preferences.getString("setting_audio_source", "0"));
    intervalPlay = Long.parseLong(preferences.getString("setting_interval_play", "20000"));
    intervalRecord = Long.parseLong(preferences.getString("setting_interval_record", "5000"));
    radiusPlay = Float.parseFloat(preferences.getString("setting_radius_play", "20"));
    radiusRecord = Float.parseFloat(preferences.getString("setting_radius_record", "5"));
  }

  public static String getResource(String resource) {
    File home = new File(Environment.getExternalStorageDirectory(), HOME);
    File resources = new File(home, RESOURCES);
    resources.mkdirs();
    return new File(resources, resource).getAbsolutePath();
  }
}
